//***************************************************************************
//
//  ̧......: LCD_driver.c
//  ......: ATMEL Norway
//  Ώ......: ATmega169
//  ߲....: IAR EWAAVR 2.28a
//  e......: AVR Butterfly LCDɎgp֐
//  Ŕԍ....: 1.0
//
//  N   - VER. - 											- 
//  20021015 - 1.0  - STK502pɏ							- JLL
//  20030116 - 1.0  - AVR Butterflyɺޕ␳						- KS
//
//***************************************************************************

#include "iom169.h"
#include "LCD_driver.h"
#include "main.h"										// DEBUG!!!

#define FALSE   0
#define TRUE    (!FALSE)

/* ϐ` */

extern unsigned char gButtonTimeout;					// ޮèԍXV׸(ݸޖh~up) (button.c)
extern BOOL gAutoPressJoystick;							// ͌JԂ׸(FALSE=~,AUTO=Ԋu,TRUE=ON)
char gLCD_Update_Required = FALSE;						// LCD\XVv׸
char LCD_Data[LCD_REGISTER_COUNT];						// LCDDRޯ̧(ޯ̧LCDDRޯ̧LCDDR)
char gTextBuffer[TEXTBUFFER_SIZE];						// ޯ̧(: ޯ7=_Ŏw)
signed char gScroll;									// ۰ٗp\Jnʒu(-6`+25)
char gScrollMode;										// ۰ON/OFF׸
char gLCD_Start_Scroll_Timer = 0;						// ۰يԊuvl
char gFlashTimer = 0;									// _Ŏvl
char gColon = 0;										// (:)\ON/OFF׸

__flash unsigned int LCD_character_table[] =			// ASCIILCD ްϊ\
{
	0x0A51,		// 2A:	  '*'		(o:xLɎgp)
	0x2A80,		// 2B:	  '+'		'+'
	0x0000,		// 2C:	  ','		(`)
	0x0A00,		// 2D:	  '-'		'-'
	0x0A51,		// 2E:	  '.'		(o:xLp:gp)
	0x0000,		// 2F:	  '/'		(`)
	0x5559,		// 30:	  '0'		'0'
	0x0118,		// 31:	  '1'		'1'
	0x1e11,		// 32:	  '2'		'2'
	0x1b11,		// 33:	  '3'		'3'
	0x0b50,		// 34:	  '4'		'4'
	0x1b41,		// 35:	  '5'		'5'
	0x1f41,		// 36:	  '6'		'6'
	0x0111,		// 37:	  '7'		'7'
	0x1f51,		// 38:	  '8'		'8'
	0x1b51,		// 39:	  '9'		'9'
	0x0000,		// 3A:	  ':'		(`)
	0x0000,		// 3B:	  ';'		(`)
	0x0000,		// 3C:	  '<'		(`)
	0x0000,		// 3D:	  '='		(`)
	0x0000,		// 3E:	  '>'		(`)
	0x0000,		// 3F:	  '?'		(`)
	0x0000,		// 40:	  '@'		(`)
	0x0f51,		// 41/61: 'A'/'a'	'A'
	0x3991,		// 42/62: 'B'/'b'	'B'
	0x1441,		// 43/63: 'C'/'c')	'C'
	0x3191,		// 44/64: 'D'/'d')	'D'
	0x1e41,		// 45/65: 'E'/'e')	'E'
	0x0e41,		// 46/66: 'F'/'f')	'F'
	0x1d41,		// 47/67: 'G'/'g')	'G'
	0x0f50,		// 48/68: 'H'/'h')	'H'
	0x2080,		// 49/69: 'I'/'i')	'I'
	0x1510,		// 4A/6A: 'J'/'j')	'J'
	0x8648,		// 4B/6B: 'K'/'k')	'K'
	0x1440,		// 4C/6C: 'L'/'l')	'L'
	0x0578,		// 4D/6D: 'M'/'m')	'M'
	0x8570,		// 4E/6E: 'N'/'n')	'N'
	0x1551,		// 4F/6F: 'O'/'o')	'O'
	0x0e51,		// 50/70: 'P'/'p')	'P'
	0x9551,		// 51/71: 'Q'/'q')	'Q'
	0x8e51,		// 52/72: 'R'/'r')	'R'
	0x9021,		// 53/73: 'S'/'s')	'S'
	0x2081,		// 54/74: 'T'/'t')	'T'
	0x1550,		// 55/75: 'U'/'u')	'U'
	0x4448,		// 56/76: 'V'/'v')	'V'
	0xc550,		// 57/77: 'W'/'w')	'W'
	0xc028,		// 58/78: 'X'/'x')	'X'
	0x2028,		// 59/79: 'Y'/'y')	'Y'
	0x5009,		// 5A/7A: 'Z'/'z')	'Z'
	0x0000,		// 5B:	  '['		(`)
	0x0000,		// 5C:	  '\'		(`)
	0x0000,		// 5D:	  ']'		(`)
	0x0000,		// 5E:	  '^'		(`)
	0x0000		// 5F:	  '_'		(`)
};

//*****************************************************************************
//*
//*	֐	: LCD_Init
//*		: Ȃ
//*	߂l	: Ȃ
//*	ړI	: ݸ,׽ĂȂǂLCDݒLCD\ޯ̧
//*
//*****************************************************************************

void LCD_Init (void)
{
	LCD_AllSegments(FALSE);								// LCD ޯ̧
	LCD_CONTRAST_LEVEL(LCD_INITIAL_CONTRAST);			// LCD׽Ēlݒ
	LCDCRB = (1<<LCDCS) | (3<<LCDMUX0) | (7<<LCDPM0);	// 񓯊ۯI,SCOM݂ƑS ݋
	LCDFRR = (0<<LCDPS0) | (7<<LCDCD0);					// 32.0HzƂȂLCDOuݒ
	LCDCRA = (1<<LCDEN) | (1<<LCDAB);					// d͔g`LCD싖
	LCDCRA |= (1<<LCDIE);								// LCDڰъJn荞݋
	gLCD_Update_Required = FALSE;						// LCD\XVv׸ޏ
}

//*****************************************************************************
//*
//*	֐	: LCD_WriteDigit
//*		: c		: \
//*			  digit : 0\ʒu(:0=1)
//*	߂l	: Ȃ
//*	ړI	: LCDDRޯ̧ɑΉ ްݒ(LCDDRޯ̧lLCD荞݂ŕ\)
//*
//*****************************************************************************

void LCD_WriteDigit(char c, char digit)
{
	unsigned int seg = 0x0000;							// ɑΉ龸Ēl
	char mask, nibble;									// َՕl,Ēl̑Ήْl
	char *ptr;											// LCDDRޯ̧ʒu(߲)
	char i;												// Ɨp

	if (digit > 5)										// 6zwŖA
		return;
	if ((c >= '*') && (c <= 'z'))						/* L */
	{
		if (c >= 'a')									// ȂA啶ɕϊ
			c &= ~0x20;
		c -= '*';										// '*'(0x2A)0ɕύX
		seg = LCD_character_table[c];					// ΉĒl擾
    }
	if (digit & 0x01)									// wȂAَՕl擾
		mask = 0x0F;
	else												// wȂAَՕl擾
		mask = 0xF0;
	ptr = LCD_Data + (digit >> 1);						// LCDDRQŉLCDDRʒu擾(հ ޲ނLCDDR蓖ĎQ)
	for (i = 0; i < 4; i++)								/* ْPʏ:1=16ޯ=4ޯ(1)~4 */
	{
		nibble = seg & 0x000F;							// Ήْl擾
		seg >>= 4;										// Ēlقŉوʒuֈړ
		if (digit & 0x01)								// wȂAΉق޲ēوʒuֈړ
			nibble <<= 4;
		*ptr = (*ptr & mask) | nibble;					// ΉْlLCDDRޯ̧ɐݒ(ْlێ)
		ptr += 5;										// ޯ̧LCDDRʒu擾(߲is)
	}
}

//*****************************************************************************
//*
//*	֐	: LCD_AllSegments(char show)
//*		: show : _/wl([TRUE|FALSE])
//*	߂l	: Ȃ
//*	ړI	: S_܂͑SLCDDRޯ̧
//*
//*****************************************************************************

void LCD_AllSegments(char show)
{
	unsigned char i;									// Ɨp

	if (show)											// _wőSޯ1l擾
		show = 0xFF;
	for (i=0; i < LCD_REGISTER_COUNT; i++)				// LCDޯ̧Sl_(0xFF)/(0x00)ŏ
		*(LCD_Data + i) = show;
}

//*****************************************************************************
//*
//*	֐	: LCD_SOF_interrupt (LCD荞ݏٰ)
//*		: Ȃ
//*	߂l	: Ȃ
//*	ړI	: LCDޯ̧LCDDRݒ,e׸ލXV/ݒ
//*
//*****************************************************************************

#pragma vector = LCD_SOF_vect
__interrupt void LCD_SOF_interrupt(void)
{
	static char LCD_timer = LCD_TIMER_SEED;				// ۰ّxvl
	char c;												// Pʏ
	char c_flash;										// PʏPʓ_Ŏw׸
	char flash;											// ݸp/_׸
	char EOL;											// I׸(Iʒu)
	unsigned char i;									// Ɨp
	static char timeout_count;							// ݸޖh~Ԍvl
	static char auto_joystick_count;					// ͌JԂԊuvl

	/* ޮè ݸޖh~ */
	if(!gButtonTimeout)									/* ޮèԍXV֎~(ݸޖh~) */
	{
		timeout_count++;								// ݸޖh~Ԍvlis
		if(timeout_count > 3)							// ݸޖh~ԏIȂA
		{
			gButtonTimeout = TRUE;						// ޮèԍXV(ݸޖh~ԏI)׸ސݒ
			timeout_count = 0;							// ݸޖh~Ԍvl
		}
	}
	/* ͌JԂԊu(main.c) */
	if(gAutoPressJoystick == AUTO)						/* ͌JԂԊuL */
	{
		auto_joystick_count++;							// ͌JԂԊuvlis
		if(auto_joystick_count > 16)					// Ԋuo߂ȂA
		{
			gAutoPressJoystick = TRUE;					// ͌JԂv׸ސݒ
			auto_joystick_count = 15;					// ͌JԂԊuvJn
		}
	}
	else
		auto_joystick_count = 0;						// ͌JԂԊuvl

	/* ۰ّx */
	LCD_timer--;										// ۰ّxvl
	if (gScrollMode)									/* ۰ON */
	{
		if (LCD_timer == 0)								/* ۰ّxԌoߎ */
		{
			if (gLCD_Start_Scroll_Timer == 0)			// ۰يԊuo߂ȂA
			{
				gLCD_Update_Required = TRUE;			// LCD\XVv׸ސݒ
			}
			else										// ۰يԊuvȂA
				gLCD_Start_Scroll_Timer--;				// ۰يԊuvl
		}
	}
	else												/* ۰OFF */
    {
//		cbi(LCDCRA, LCDIE);								// DEBUG:(۰ً֎~LCD荞݋֎~)
		gScroll = 0;									// ۰ٗp\Jnʒu
	}
	/* LCD\XV */
	EOL = FALSE;										// I׸(Iʒu)
	if (gLCD_Update_Required == TRUE)					/* LCD\XVv */
	{
		/* _ŋ(/_) */
		if (gFlashTimer < (LCD_FLASH_SEED >> 1))		// _ŊԊȗOԂȂA
			flash = 0;									// _׸ސݒ
		else											// _ŊԊǔ㔼ԂȂA
			flash = 1;									// ׸ސݒ
		/* Pʕ\ */
		for (i = 0; i < 6; i++)							/* (LCD6) */
		{
			if ((gScroll+i) >= 0 && (!EOL))				/* ((ΉLʒuŏIʒuB)) */
			{
				c = gTextBuffer[i + gScroll];			// ޯ̧Ή擾
				c_flash = c & 0x80 ? 1 : 0;				// Pʓ_(/_)w׸ގ擾
				c = c & 0x7F;							// ̂ݗL(Pʓ_Ŏwޯĉ)
				if (c == '\0')							// IqȂA
					EOL = i+1;							// I׸(Iʒu)ݒ/ۑ
			}
			else										/* ((Ήʒu܂͊ɍŏII)) */
				c = ' ';								// 󔒕擾
			if (c_flash && flash)						// Pʓ_Ŏw芎_ŏԂȂA
				LCD_WriteDigit(' ', i);					// LCDDRޯ̧ɋ󔒕ΉĒlݒ
			else										// Pʓ_ŎwȂ܂͓_œ_ԂȂA
				LCD_WriteDigit(c, i);					// LCDDRޯ̧ɑΉΉĒlݒ
		}
		for (i = 0; i < LCD_REGISTER_COUNT; i++)		// LCDDRޯ̧lLCDDRɓ]()
			*(pLCDREG + i) = *(LCD_Data+i);
		if (gColon)										// (:)\ONwȂA
			*(pLCDREG + 8) = 0x01;						// ΉLCDDRɺ(:)\ ޯĒlݒ
		else											// (:)\OFFwȂA
			*(pLCDREG + 8) = 0x00;						// ΉLCDDRɺ(:)\ ޯĒl
		if (EOL == 1)									// ۰ٍŏIBȂA
			gScroll = -6;								// ۰ٗp\Jnʒu
		else											// ۰ٍŏIBȂA
			gScroll++;									// ۰ٗp\Jnʒuis
		gLCD_Update_Required = FALSE;					// LCD\XVv׸މ
	}
	/* ۰يxvlĎn */
	if (LCD_timer == 0)									/* ۰ّxvI */
	{
/*		if ((gScroll <= 0) || EOL)						// ۰قőS\ȊOȂA
			LCD_timer = LCD_TIMER_SEED/2;				// ۰ّxv{Ďn
		else*/											// ȊOȂA
			LCD_timer = LCD_TIMER_SEED;					// ۰ّxvĎn
	}
	/* _Ŏvl */
	if (gFlashTimer == LCD_FLASH_SEED)					// _ŎvIȂA
		gFlashTimer= 0;									// _ŎvĎn
	else												// _ŎvȂA
		gFlashTimer++;									// _Ŏvis
}
